unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ScktComp;

type
  Twebio_ascii_client = class(TForm)
    gb_io: TGroupBox;
    cb_input0: TCheckBox;
    cb_input1: TCheckBox;
    cb_output0: TCheckBox;
    cb_output1: TCheckBox;
    lb_counter0: TLabel;
    lb_counter1: TLabel;
    ed_counter0: TEdit;
    ed_counter1: TEdit;
    bt_counterread0: TButton;
    bt_counterread1: TButton;
    bt_counterclear0: TButton;
    bt_counterclear1: TButton;
    bt_counterreadall: TButton;
    bt_counterclearall: TButton;
    lb_counterall: TLabel;
    bt_inputsread: TButton;
    bt_outputsread: TButton;
    cb_output_polling: TCheckBox;
    cb_input_polling: TCheckBox;
    cb_counter_polling: TCheckBox;
    Label1: TLabel;
    ed_interval: TEdit;
    gb_connection: TGroupBox;
    Label2: TLabel;
    ed_ip: TEdit;
    ed_port: TEdit;
    bt_connect: TButton;
    bt_disconnect: TButton;
    StatusBar1: TStatusBar;
    ClientSocket1: TClientSocket;
    timer_polling: TTimer;
    ed_password: TEdit;
    lb_port: TLabel;
    lb_password: TLabel;
    procedure bt_connectClick(Sender: TObject);
    procedure bt_disconnectClick(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure cb_outputMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_outputsreadClick(Sender: TObject);
    procedure bt_inputsreadClick(Sender: TObject);
    procedure bt_counterreadClick(Sender: TObject);
    procedure bt_counterclearClick(Sender: TObject);
    procedure bt_counterreadallClick(Sender: TObject);
    procedure bt_counterclearallClick(Sender: TObject);
    procedure timer_pollingTimer(Sender: TObject);
    procedure ed_intervalChange(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  webio_ascii_client: Twebio_ascii_client;

implementation

{$R *.DFM}

procedure Twebio_ascii_client.bt_connectClick(Sender: TObject);
begin
  if ed_ip.Text <> '' then
  begin
    ClientSocket1.Host := ed_ip.Text;
    ClientSocket1.Port := strtoint(ed_port.Text);
    ClientSocket1.Active := True;
  end;  
end;

procedure Twebio_ascii_client.bt_disconnectClick(Sender: TObject);
begin
  ClientSocket1.Active := False;
end;

procedure Twebio_ascii_client.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar1.SimpleText := 'Connected to ' + ed_ip.Text;
  bt_connect.Enabled := False;
  bt_disconnect.Enabled := True;
  gb_io.Enabled := True;
end;

procedure Twebio_ascii_client.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ClientSocket1.Active := False;
  StatusBar1.SimpleText := 'No Connection';
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ClientSocket1.Active := False;
  StatusBar1.SimpleText := 'Error ' + inttostr(ErrorCode) + ' - No Connection';
  ErrorCode := 0;
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.cb_outputMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if sender = cb_output0 then
    if cb_output0.Checked then
      ClientSocket1.Socket.
         SendText('GET /outputaccess0?PW=' + ed_password.Text + '&State=ON&')
    else
      ClientSocket1.Socket.
         SendText('GET /outputaccess0?PW=' + ed_password.Text + '&State=OFF&')
  else
    if cb_output1.Checked then
      ClientSocket1.Socket.
         SendText('GET /outputaccess1?PW=' + ed_password.Text + '&State=ON&')
    else
      ClientSocket1.Socket.
         SendText('GET /outputaccess1?PW=' + ed_password.Text + '&State=OFF&');
end;

procedure Twebio_ascii_client.bt_outputsreadClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /output?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_inputsreadClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /input?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counterreadClick(Sender: TObject);
begin
  if sender = bt_counterread0 then
    ClientSocket1.Socket.SendText('GET /counter0?PW=' + ed_password.Text + '&')
  else
    ClientSocket1.Socket.SendText('GET /counter1?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counterclearClick(Sender: TObject);
begin
  if sender = bt_counterclear0 then
    ClientSocket1.Socket.
        SendText('GET /counterclear0?PW=' + ed_password.Text + '&')
  else
    ClientSocket1.Socket.
        SendText('GET /counterclear1?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counterreadallClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /counter?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_client.bt_counterclearallClick(Sender: TObject);
begin
  ClientSocket1.Socket.
      SendText('GET /counterclear?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_client.timer_pollingTimer(Sender: TObject);
begin
  if ClientSocket1.Active and cb_output_polling.Checked then
    ClientSocket1.Socket.SendText('GET /output?PW=' + ed_password.Text + '&');
  if ClientSocket1.Active and cb_input_polling.Checked then
    ClientSocket1.Socket.SendText('GET /input?PW=' + ed_password.Text + '&');
  if ClientSocket1.Active and cb_counter_polling.Checked then
    ClientSocket1.Socket.SendText('GET /counter?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.ed_intervalChange(Sender: TObject);
begin
  timer_polling.Interval := strtoint(ed_interval.Text);
end;

procedure Twebio_ascii_client.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var ReceiveString : String;
    SemiPosition : integer;
    OutputValue : word;
    InputValue : word;
begin
  ReceiveString := ClientSocket1.Socket.ReceiveText;
  if Receivestring[1] = 'o' then //Output-Meldungen auswerten
  begin
    OutputValue := strtoInt(copy(ReceiveString,
     pos(';',ReceiveString)+1,length(ReceiveString)-pos(';',ReceiveString)-1));
    if OutputValue and 1 = 1 then  //Output0 auswerten
      cb_output0.Checked := True
    else
      cb_output0.Checked := False;
    if OutputValue and 2 = 2 then  //Output1 auswerten
      cb_output1.Checked := True
    else
      cb_output1.Checked := False;
  end;
  if Receivestring[1] = 'i' then  //Input-Meldungen auswerten
  begin
    InputValue := strtoInt(copy(ReceiveString,
       pos(';',ReceiveString)+1,
       length(ReceiveString)-pos(';',ReceiveString)-1));
    if InputValue and 1 = 1 then   //Input0 auswerten
      cb_input0.Checked := True
    else
      cb_input0.Checked := False;
    if InputValue and 2 = 2 then   //Input1 auswerten
      cb_input1.Checked := True
    else
      cb_input1.Checked := False;
  end;
  if Receivestring[1] = 'c' then  //Counter-Meldungen auswerten
  begin
    if copy(ReceiveString, 8, 1) = '0' then  //Counter0
      ed_counter0.Text := copy(ReceiveString, 10,length(ReceiveString)-10);
    if copy(ReceiveString, 8, 1) = '1' then  //Counter1
      ed_counter1.Text := copy(ReceiveString, 10,length(ReceiveString)-10);
    if copy(ReceiveString, 8, 1) = ';' then  //alle Counter
    begin
      delete(ReceiveString, 1, pos(';',ReceiveString));
      ed_counter0.Text := copy(ReceiveString, 1,pos(';',ReceiveString)-1);
      delete(ReceiveString, 1, pos(';',ReceiveString));
      ed_counter1.Text := copy(ReceiveString, 1,length(ReceiveString)-1);
    end;
  end;  
end;

procedure Twebio_ascii_client.FormCreate(Sender: TObject);
begin
  StatusBar1.SimpleText := 'No Connection';
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

end.
